#ifndef _BADPENGUIN_ANSI_H
#define _BADPENGUIN_ANSI_H

// Bad Penguin ANSI utilities
// for coloured and fancy terminal output
// @1999 by Antonio Gallo

#include <stdio.h>

// Foreground Colors
#define FG_BLACK	"\033[30m"
#define FG_RED		"\033[1;31m"
#define FG_GREEN	"\033[1;32m"
#define FG_ORANGE	"\033[33m"
#define FG_YELLOW	"\033[1;33m"
#define FG_BLUE		"\033[1;34m"
#define FG_MAGENTA	"\033[1;35m"
#define FG_PURPLE	FG_MAGENTA
#define FG_CYAN		"\033[1;36m"
#define FG_WHITE	"\033[37m"


// Background Colors
#define BG_BLACK	"\033[40m"
#define BG_RED		"\033[41m"
#define BG_GREEN	"\033[42m"
#define BG_ORANGE	"\033[43m"
#define BG_BLUE		"\033[44m"
#define BG_MAGENTA	"\033[45m"
#define BG_CYAN		"\033[46m"
#define BG_WHITE	"\033[47m"

// Blink (not sure about blink off)
#define BLINK_ON	"\033[5m"
#define BLINK_OFF	"\033[m"
#define BOLD_ON		"\033[1m"
#define BOLD_OFF	"\033[2m"
#define REVERSE_ON	"\033[7m"
#define ALL_OFF		"\033[m"
#define BELL		"\007"
//#define RESET_TERM	"\033[0;10;39m"
#define RESET_TERM	"\033c"

// Misc
#define CURSOR_ON	"\033[?25h"
#define CURSOR_OFF	"\033[?25l"


// printf Macro
#define color(X)	printf("%s",(X))
#define printERROR	printf("%s",FG_RED);printf
#define printWARNING	printf("%s",FG_YELLOW);printf
#define printNOTICE	printf("%s",FG_PURPLE);printf
#define printSUCCESS	printf("%s",FG_GREEN);printf
#define printTITLE	printf("%s",FG_CYAN);printf
#define normal_color()  printf("%s",FG_WHITE)

#define ansi_goto(Y,X)	printf( "\033[%i;%iH", (Y), (X) )
#define ansi_color(X)	printf( "%s", (X) )
//#define ansi_clrscr()   printf( "\033[2J\033[0;0H"
 )
#define ansi_clrscr()   printf( "\033[H\033[J"
 )
/* title put string in RED/BLUE at 0,0 and perform a CLREOL */
#define ansi_title(X)   printf( "\033[0;31m\033[47m\033[0;0H"); printf("%s\033[K",X)


/* CURSOR MOVEMENT */
#define	ansi_cursor_up(X)	printf( "\033[%iA"
, (X) )


#ifdef TODO


MOVE_HOME() {
	echo "\033[H"
}

MOVE_LOWERLEFT() {
	echo "\033[1;25r\033[25;1H
"
}


MOVE_DOWN() {
	echo "\033[$1B\c"
}

MOVE_RIGHT() {
	echo "\033[$1C\c"
}

MOVE_LEFT() {
	echo "\033[$1d\c"
}

PUSH_CURSOR() {
	echo "\033[s\c"
}

POP_CURSOR() {
	echo "\033[u\c"
}


CLREOL() {
	echo "\033[K\c"
}

CLREOS() {
	echo "\033[J\c"
}



BACKTITLE() {
	echo "\033[0;0H\c"
	echo "${FG_CYAN}${BG_BLUE}\c"
	echo "$1"
	echo "==============================================================================="
}

#endif

#endif
