#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include "badpenguin-chain.h"

// Create a chain struct
TChain *chain_create() {
  return calloc( 1, sizeof(TChain) );
}

// Create a chain struct
TChainItem *chain_create_item() {
  return calloc( 1, sizeof(TChainItem) );
}

// Delete a whole chain structure
int chain_cleanall(TChain *chain) {
  TChainItem *item, *old;
  assert(chain!=NULL);
  // Delete Items
  item = chain->head;
  while (item!=NULL) {
    // Dispose data
    if (item->name != NULL) free(item->name);
    //TO THIS MANUALLY ! if (item->data != NULL) free(item->data);
    old = item;
    item = item->next;
    free(old);
  }
  // Reset chain
  chain->head = NULL;
  chain->tail = NULL;
  chain->count = 0;  
  return 0;
}



// Delete a whole chain structure
int chain_delete(TChain *chain) {
  assert(chain!=NULL);
  chain_cleanall(chain);
  free(chain);
  return 0;
}


// Append a new item at the end of the chain
TChainItem *chain_append(TChain *chain) {
  assert(chain!=NULL);
  // ... if the chain is empty
  if (chain->tail==NULL) {
    chain->head = chain_create_item();
    chain->tail = chain->head;
    chain->count= 1;
    return chain->tail;
  }
  // ... if the chain is not empty
  // append the new item
  chain->tail->next = chain_create_item();
  chain->tail->next->prev = chain->tail;
  // move forward the tail
  chain->count++;
  chain->tail = chain->tail->next;
  return chain->tail;
}


// Insert a new item after a chainItem with a given name
TChainItem *chain_insert(TChain *chain, char *itemName, int order) {
  TChainItem *localItem, *newItem, *prevItem;
  int diff;
  
  assert(chain!=NULL);
  assert(itemName!=NULL);
  localItem = chain->head;
  while (localItem != NULL ) {
    if (localItem->name != NULL ) {
      diff = strcmp(localItem->name,itemName);
      if ( ((order==1)&&(diff<0)) || ((order==0)&&(diff>0)) ) {
        //printf("chain_insert_after: found localitem %s greater then %s \n", localItem->name, itemName );
	// add new item
	newItem = chain_create_item();
	chain->count++;
	// set
	newItem->next = localItem;
        if (localItem->prev==NULL) {
	  chain->head = newItem;
	  localItem->prev = newItem;
	} else {
	  prevItem = localItem->prev;
	  newItem->prev = prevItem;
	  localItem->prev = newItem;
	  // adjust prev
	  prevItem->next = newItem;
	}	
	// done
	return newItem;
      }
    }
    localItem = localItem->next;
  }
  // not found append
  //printf("chain_insert_after: hit bottom or chain empty, appending ...\n");
  return chain_append(chain);
}
