#include <stdio.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "badpenguin-ansi.h"
#include "badpenguin-errors.h"
#include "badpenguin-fs.h"

// same as the shell command: mkdir -P -m
int makedir( char* s, mode_t m ) {
  char *f;

  // Controllo se la directory esiste gia'
  if ( 0 == file_exists(s) ) return 0;

  // Controllo se il padre esiste
  f = dirpath(s);
  if ( 0 != file_exists( f ) ) {
    printWARNING("makedir: %s does not exists !\n", f );
    normal_color();
    if ( 0 != makedir( f, m ) ) {
      printERROR("makedir: error creating %s !\n", f );
      normal_color();
      return ERROR_IO;
    }
  }
  // L'albero del padre e' stato creato, puoi creare la foglia
  return mkdir( s, m );
}
