#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "badpenguin-ansi.h"
#include "badpenguin-errors.h"

#define MOVE_BUFFER_SIZE	4096

// Try to move a single file, first using the rename syscall
// and the copying the file to the target file and unlinking
// the source file.
// Keep out: the target directory should exist
int move_file( char* source, char* target) {
  int readed, writed;
  char *buffer;
  FILE *fds, *fdt;
  
  // Try to rename
  if ( 0 == rename(source,target) ) return 0;
  // Move
  printf("move_file: moving %s to %s\n", source, target);
  fds = fopen(source,"r");
  if (fds==NULL) {
    printERROR("move_file: impossibile aprire in lettura %s\n", source);
    normal_color();
    return -1;
  }
  fdt = fopen(target,"w");
  if (fds==NULL) {
    printERROR("move_file: impossibile aprire in scrittura %s\n", target);
    normal_color();    
    fclose(fds);
    return -1;
  }
  
  // alloc buffer
  buffer = calloc( MOVE_BUFFER_SIZE, sizeof(char) );
  assert(buffer!=NULL);
  
  while( ! feof(fds) ) {
    readed = fread( buffer, 1, MOVE_BUFFER_SIZE, fds );
    writed = fwrite( buffer, 1, readed, fdt );
    if ( readed != writed ) {
      printERROR("move_file: errore I/O letti %i, scritti %i \n", readed, writed);
      normal_color();      
      fclose(fds);
      fclose(fdt);
      free(buffer);
      // clean up the death body :-)
      unlink(target);
      return -1;
    }
  }
  fclose(fds);
  fclose(fdt);
  free(buffer);  
  printf("move_file: tutto OK, unlinking ...");
  return unlink(source);
}
