#include <sys/wait.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#define __USE_GNU
#include <unistd.h>


// Run a command using the shell
int runshell (char *command) {
  int pid, status;
  pid = fork();
  if (pid == -1) return -1;
  if (pid == 0) {
    char *argv[4];
    argv[0] = "sh";
    argv[1] = "-c";
    argv[2] = command;
    argv[3] = 0;
    execve("/bin/sh", argv, environ);
    exit(127);
  }
  do {
    if (waitpid(pid, &status, 0) == -1) {
      if (errno != EINTR) return -1;
    } else {
      return status;
    }
    sleep(1);
  } while(1);
  return -1; // fake the compiler :-)
}
